﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private xui As XUI 'ignore
	Private frm As Form
	
	Private btnUp As Button
	Private btnDown As Button
	Private btnSave As Button
	Private btnCancel As Button
	Private clvColumns As CustomListView
	Private chkVisible As CheckBox
	Private lblColNaziv As Label
	Private txtLenght As TextField
	Private mapColumns As Map 
	
	Private mSelectedIndex As Int
	Private mPrevSelectedIndex As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(cols As Map) 
	
	mapColumns = cols 
	
	frm.Initialize("Columns", 450dip, 820dip)
	frm.RootPane.LoadLayout("tblGridView")
	frm.Resizable = False
	frm.SetFormStyle("UTILITY")
	
	' za vsako kolono vpišemo v customlistview
	For i = 0 To mapColumns.Size - 1
		Dim itm As colRec = mapColumns.GetValueAt(i)
		clvColumns.add(CreateListItem(itm, clvColumns.AsView.Width, 40dip), itm)
	Next
	
	Dim Visina As Double = 150dip + (40dip * (i + 1))
	frm.WindowHeight = Visina

End Sub

' View form 
Public Sub ViewColumns 
	frm.ShowAndWait
End Sub


' Creating list of items 
Private Sub CreateListItem(strRec As colRec, Width As Int, Height As Int) As B4XView
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	p.LoadLayout("ColItems")
	chkVisible.Checked = strRec.colVisible
	lblColNaziv.Text = strRec.colId
	txtLenght.Text = strRec.colLength
	Return p
End Sub



' closing form 
Private Sub btnCancel_Click
	frm.Close
End Sub

' if user click on checkbox 
Private Sub chkVisible_CheckedChange(Checked As Boolean)
	Dim Index As Int =  clvColumns.GetItemFromView(Sender)
	Dim item As CLVItem = clvColumns.GetRawListItem(Index)
	Dim pnl As B4XView = item.Panel.GetView(0)
	Dim chk As CheckBox = pnl.GetView(0)
	Dim id As Label = pnl.GetView(1)
	Dim length As TextField = pnl.GetView(2)
	' najdemo originalno dolžino
	Dim strRec As colRec = mapColumns.Get(id.Text)
	If chk.Checked = False Then length.Text = 0 Else length.Text = strRec.colLength
	
End Sub

' If user click on item 
Private Sub clvColumns_ItemClick (Index As Int, Value As Object)
	If mPrevSelectedIndex <> - 1 Then
		SetSelectedColor(mPrevSelectedIndex, False)
	End If

	mSelectedIndex = Index
	SetSelectedColor(mSelectedIndex, True)
	mPrevSelectedIndex = mSelectedIndex
	
End Sub

' If user input length and press enter 
Private Sub txtLenght_Action
	' postavimo kurzur na naslednji zapis
	SetSelectedColor(mSelectedIndex, False)
	mSelectedIndex = mSelectedIndex + 1
	SetSelectedColor(mSelectedIndex, True)
	mPrevSelectedIndex = mSelectedIndex
	
	clvColumns.JumpToItem(mSelectedIndex)
	Dim item As CLVItem = clvColumns.GetRawListItem(mSelectedIndex)
	Dim pnl As B4XView = item.Panel.GetView(0)
	Dim length As TextField = pnl.GetView(2)
	length.RequestFocus
	' txtLenght.RequestFocus
End Sub


' moving data in list
Sub btnUp_Click
	
	If mSelectedIndex = -1 Then Return
	
	Dim strRec As colRec = clvColumns.GetValue(mSelectedIndex)
	clvColumns.RemoveAt(mSelectedIndex)
	clvColumns.InsertAt(mSelectedIndex - 1, CreateListItem(strRec, clvColumns.AsView.Width, 40dip), strRec)
	mSelectedIndex = mSelectedIndex - 1
	SetSelectedColor(mSelectedIndex, True)
	mPrevSelectedIndex = mSelectedIndex
	btnUp.Visible = mSelectedIndex > 0
	btnDown.Visible = mSelectedIndex < (clvColumns.Size - 1)
End Sub

' moving data up 
Sub btnDown_Click
	
	If mSelectedIndex = -1 Then Return
	
	Dim strRec As colRec = clvColumns.GetValue(mSelectedIndex)
	clvColumns.RemoveAt(mSelectedIndex)
	clvColumns.InsertAt(mSelectedIndex + 1, CreateListItem(strRec, clvColumns.AsView.Width, 40dip), strRec)
	mSelectedIndex = mSelectedIndex + 1
	SetSelectedColor(mSelectedIndex, True)
	mPrevSelectedIndex = mSelectedIndex
	btnUp.Visible = mSelectedIndex > 0
	btnDown.Visible = mSelectedIndex < (clvColumns.Size - 1)
End Sub

' selected item 
Private Sub SetSelectedColor(Index As Int, Selected As Boolean)
	Dim Color As Int
	If Selected Then
		Color = xui.Color_RGB(135,34,28)
	Else
		Color = xui.Color_Transparent
	End If
	clvColumns.GetPanel(Index).Color = Color
End Sub

' return map  
Public Sub ReturnConfigAsMap As Map 
	Return mapColumns
End Sub

' click on save button 
Private Sub btnSave_Click
	' redefining  map 
	mapColumns.Clear
	
	' for all items in customlistview
	For x = 0 To clvColumns.Size - 1 
		Dim item As CLVItem = clvColumns.GetRawListItem(x)
		Dim pnl As B4XView = item.Panel.GetView(0)
		Dim chk As CheckBox = pnl.GetView(0)
		Dim length As TextField = pnl.GetView(2)
		
		' cols 
		Dim col As colRec = clvColumns.GetValue(x) 
		' changing data in maps
		col.colPos = x 
		If chk.Checked = True Then col.colVisible = True Else col.colVisible = False 
		col.colLength = length.Text
		mapColumns.Put(col.colId, col) 	
	Next

	frm.close
End Sub
