﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private xui As XUI 'ignore
	Private frm As Form
	
	Private Query As String = ""
	Type colRec(colId As String, colVisible As Boolean, colLength As Int, colOrigLength As Int, colPos As Int, colOrigPos As Int, colType As String)
	Private const TableMenuItems() As String = Array As String("Filter", "Clear filter", "Show columns", "Hide column", "Save layout", "Reset layout", "Export XLS")
	
	Private tblView As TableView
	Private ModulName As String = ""
		
	Private lblColNaziv As Label
	Private AddWhere As String

	Public NeedToInit As Boolean = False
	Public mapColumns As Map
	Public SelectedColumnName As String
	Public UserID As Int 

	Private clvIzbor As CustomListView
	Private searchDialog As B4XDialog
	Private txtSearchString As TextField
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(NamedTableView As TableView, NameOfModule As String)
	tblView = NamedTableView
	ModulName = NameOfModule
	mapColumns.Initialize
	
	AddWhere = $" cfgUserID = ${UserID} and cfgTableName = '${ModulName}'"$
	
	frm.Initialize("rghtM", 180dip, 720dip)
	frm.RootPane.LoadLayout("RightMenu")
	frm.Resizable = False
	frm.SetFormStyle("UTILITY")
	
	For x = 0 To TableMenuItems.Length - 1
		clvIzbor.add(CreateMenuItems(TableMenuItems(x), clvIzbor.AsView.Width, 30dip), TableMenuItems(x))
	Next
	frm.WindowHeight = (x * 30dip) + 75dip
	
End Sub

' Show menu (right click on table - header)
Sub ShowMenu(Left As Int, Top As Int) 
	frm.WindowLeft = Left
	frm.WindowTop = Top
	
	frm.ShowAndWait
End Sub


' Init existing config
Private Sub InitConfig

	' for all columsn in tableview 
	For x = 0 To tblView.ColumnsCount - 1
		
		Dim colName As String = tblView.GetColumnHeader(x)
		Dim colVisible As Int = 0
		If tblView.GetColumnVisible(x) = True Then colVisible = 1
		Dim colLength As Int = tblView.GetColumnWidth(x)
		Dim recCol As colRec = mapColumns.GetValueAt(x)
			
		Query = $"Insert into cfgTables(cfgUserID, cfgTableName, cfgColumnName, cfgColumnVisible, cfgColumnLength, cfgColumnOrigLength, cfgColumnOrigPos, cfgColumnCurrPos, cfgColumnType)
		          values(${UserID}, '${ModulName}', '${colName}', ${colVisible}, ${colLength}, ${colLength}, ${x}, ${x}, '${recCol.colType}')"$
		DbComm.WritteToDb(Query, ModulName)
	Next
	
End Sub

' check if number of columns is same in saved table 
Private Sub CheckIfColumnsOk As Boolean
	Dim bOk As Boolean = False
	
	Query = $"select count(*) as NumRec from cfgTables where ${AddWhere}"$
	Dim recNum As Int = DbComm.sqllite.ExecQuerySingleResult(Query)
	If recNum = tblView.ColumnsCount Then  bOk = True
	
	Return bOk
	
End Sub


' creating items for menu 
Private Sub CreateMenuItems(Item As String, Width As Int, Height As Int) As B4XView
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	p.LoadLayout("MenuItems")
	lblColNaziv.Text = Item
	Return p
End Sub


' Saving configuration 
Sub SaveConfig

	' mem current colums in tableview
	For x = 0 To tblView.ColumnsCount - 1
		Dim colName As String = tblView.GetColumnHeader(x)
		Dim colVisible As Int = 0
		If tblView.GetColumnVisible(x) = True Then colVisible = 1
		Dim colLength As Int = tblView.GetColumnWidth(x)
		
		' changing maps
		Dim cl As colRec = mapColumns.GetValueAt(x)
		cl.colLength =  tblView.GetColumnWidth(x)
		cl.colVisible = tblView.GetColumnVisible(x) 
			
		mapColumns.Put(cl.colId, cl) 

		Query = $"update cfgTables set cfgColumnVisible = ${colVisible},
		                               cfgColumnLength = ${colLength},
								       cfgColumnCurrPos = ${x}
		          where cfgUserID = ${UserID} And 
				        cfgTableName = '${ModulName}'  and 
						cfgColumnName = '${colName}'"$
		DbComm.WritteToDb(Query, ModulName)
	Next
	
End Sub

' delete existing configuration  
Private Sub DeleteConfig
	
	' delete
	Query = "delete from cfgTables where " & AddWhere
	DbComm.WritteToDb(Query, ModulName)
	
End Sub

' load user config file 
Private Sub LoadConfigAsMap
	
	' preverimo ujemanje kolon
	If CheckIfColumnsOk = False Then
		DeleteConfig
		InitConfig
	End If

	mapColumns.Clear
	
	Query = $"select * from cfgTables Where ${AddWhere}
	          order by cfgColumnCurrPos"$
	Dim rs As ResultSet = DbComm.SqlLite.ExecQuery(Query)
		
	Do While rs.NextRow
		' for all columns 
		Dim rc As colRec
		rc.colId = rs.GetString("cfgColumnName")
		Dim rv As Int = rs.GetInt("cfgColumnVisible")
		If rv = 1 Then rc.colVisible = True Else rc.colVisible = False
		rc.colLength = rs.GetInt("cfgColumnLength")
		rc.colOrigLength = rs.GetInt("cfgColumnOrigLength")
		rc.colOrigPos = rs.GetInt("cfgColumnOrigPos")
		rc.colPos = rs.GetInt("cfgColumnCurrPos")
		rc.colType = rs.GetString("cfgColumnType")
		mapColumns.Put(rc.colId, rc)
	Loop
	rs.Close
	
End Sub

' create table column with parameters 
Sub CreateColumn(ID As String, PoS As Int, Length As Int, Visible As Boolean, FieldType As String) As colRec

	Dim cl As colRec

	cl.colId = ID
	cl.colPos = PoS
	cl.colOrigPos = PoS
	cl.colLength = Length
	cl.colOrigLength = Length
	cl.colVisible = Visible
	cl.colType = FieldType
	
	' dodamo kolono še v Map
	mapColumns.Put(cl.colId, cl)
	
	Return cl
End Sub


' loading order of columsn (saved)
Sub LoadConfig As TableView
	
	' Loading configuration as map 
	LoadConfigAsMap

	Dim lCols As List
	lCols.Initialize

	For x = 0 To mapColumns.Size - 1
		lCols.Add(mapColumns.GetKeyAt(x))
	Next
	tblView.SetColumns(lCols)
	
	' for all columns in map 
	For x = 0 To mapColumns.Size - 1
		Dim rc As colRec = mapColumns.GetValueAt(x)

		tblView.SetColumnVisible(x, rc.colVisible)
		tblView.SetColumnWidth(x, rc.colLength)
	Next

	Return tblView
End Sub


' reconfiguration of items 
Sub ReconfigureItems(item() As Object) As Object
	Dim myStr(item.Length) As Object
	
	For x = 0 To mapColumns.Size - 1
		Dim strCols As colRec = mapColumns.GetValueAt(x)
		' for checkbox 
		If strCols.colType = "CHECKBOX" Then
			Dim cb As CheckBox
			cb.initialize("twcb")
			Dim val As Int = item(strCols.colOrigPos)
			If val = 1 Then cb.checked = True Else cb.Checked = False
			SetColumnStyle(x, "-fx-alignment: CENTER;")
			item(strCols.colOrigPos) = cb
		End If
		myStr(strCols.colPos) = item(strCols.colOrigPos)
	Next

	Return myStr
End Sub

' hide column 
Sub HideColumn(ColumnName As String) 
	Dim cls As colRec = mapColumns.Get(ColumnName)
	cls.colVisible = False 
	
	' shranimo v Map 
	mapColumns.Put(cls.colId, cls)
	Dim IsVisible As Int = 0 
	If cls.colVisible = True Then IsVisible = 1
	
	Query = $"update cfgTables set cfgColumnVisible = ${IsVisible}
		      where ${AddWhere} and cfgColumnName = '${ColumnName}'"$
	DbComm.WritteToDb(Query, ModulName)
	
	
End Sub

' delete saved config
Sub SetToDefaultLayout
	
	mapColumns.Clear
	
	Query = $"delete from cfgTables where ${AddWhere}"$
	DbComm.WritteToDb(Query, ModulName)

End Sub

' define style for columsn
Private Sub SetColumnStyle(Index As Int, Style As String)
	Dim jo As JavaObject = tblView
	Dim Column As JavaObject = jo.RunMethodJO("getColumns", Null).RunMethod("get", Array(Index))
	Column.RunMethod("setStyle", Array(Style))
End Sub

' export to XLS 
Sub Export2Xls(Path As String, sheetName As String, XLname As String)
  
	Dim wb As PoiWorkbook
	wb.InitializeNew(False) 'create new excel workbook
  
	'Create sheet and add the name we called the sub with
	Dim sheet1 As PoiSheet
	sheet1 = wb.AddSheet(sheetName,0)
  
	'First Line has the titles from the tblViewview
	Dim titleRow As PoiRow = sheet1.CreateRow(0)
	For i = 0 To (tblView.ColumnsCount - 1)
		titleRow.CreateCellString(i, tblView.GetColumnHeader(i))
	Next
  
	'Create first data row
	Dim dataRow As PoiRow = sheet1.CreateRow(1)
  
	'A var to hold the values of each row
	Dim rowValues() As Object

	'Go through each row
	For curSet = 0 To (tblView.Items.Size - 1)
      
		'Get the values of each row
		rowValues = tblView.Items.Get(curSet)
		'Assign the values to a temp variable to go through the values and write them to the cell
		Dim excelCell As Int = 0
		For Each s In rowValues
			dataRow.CreateCellString(excelCell,s)
			excelCell = excelCell  + 1
		Next
  
		'Go to the next row... remember, first row is title and second row is the beginning of data...
		dataRow = sheet1.CreateRow(curSet + 2)
		dataRow.RowNumber = curSet + 2
	Next
  
	wb.Save(Path, XLname)
	wb.Close
	
	' sporočilo
	Dim icon As B4XBitmap = xui.LoadBitmapResize(File.DirAssets, "SaveFlopi.png", 60dip, 60dip, True)
	Dim sf As Object = xui.Msgbox2Async("All records has ben exported to:" & Path & "\" & XLname , "Grid2Excel", "Ok", "", "", icon)
	Wait For (sf) Msgbox_Result (Result As Int)
	
  
End Sub

' Loading view for all columns
Sub ViewColumns
	
	' naložimo map
	LoadConfigAsMap
	
	' prikažemo kolone
	Dim cfgCols As configColumns
	cfgCols.Initialize(mapColumns)
	cfgCols.ViewColumns
	
	' preverimo
	mapColumns = cfgCols.ReturnConfigAsMap
	
	' zaradi sprememb v map - shranimo konfiguracijo po map-u
	SaveConfigFromMap
	
End Sub

' Saving config from map 
Private Sub SaveConfigFromMap
	

	' for all columns in map 
	For x = 0 To mapColumns.Size - 1
		Dim cols As colRec = mapColumns.GetValueAt(x)
		
		Dim colVisible As Int = 0
		If cols.colVisible = True Then colVisible = 1
			
		Query = $"update cfgTables set cfgColumnVisible = ${colVisible},
		                               cfgColumnLength = ${cols.colLength},
								       cfgColumnCurrPos = ${cols.colPos}
		          where ${AddWhere} and 
						cfgColumnName = '${cols.colId}'"$
		DbComm.WritteToDb(Query, ModulName)
	Next
	
	
End Sub


' click on button save 
Private Sub btnSave_Click
	SaveConfig 
	NeedToInit = True 
	
	frm.close
End Sub

' closing form 
Private Sub btnCancel_Click
	frm.Close 
End Sub

' mark last column as filtered
Private Sub SetFilterStyle(Index As Int, Color As String)
	
	Dim Style As String = " -fx-background-color: " & Color & ";"
	If Color = "" Then Style = ""
	Dim jo As JavaObject = tblView
	Dim columnHeader As JavaObject = jo.RunMethodJO("lookup", Array(".column-header-background"))
	Dim firstCell As JavaObject = columnHeader.RunMethodJO("getChildren", Null).RunMethod("get", Array(Index))
	firstCell.RunMethod("setStyle", Array(Style))
End Sub

' click on Item 
Private Sub clvIzbor_ItemClick (Index As Int, Value As Object)
	
	' actions in menu 
	Select Case Index
		' filter
		Case 0
			frm.Close
			searchDialog.Initialize(B4XPages.MainPage.Root)
			Dim dlg As B4XView = xui.createpanel("")
			dlg.SetLayoutAnimated(0, frm.RootPane.left, frm.RootPane.Top, 500dip, 0)
			dlg.LoadLayout("SearchItem")
	
			searchDialog.BorderColor = xui.Color_Transparent
			searchDialog.BorderCornersRadius = 10dip
			searchDialog.BackgroundColor = xui.Color_LightGray
			searchDialog.mParent.SetColorAndBorder(xui.Color_LightGray, 0dip, xui.Color_Transparent, 10dip)
			Dim rs As Object = searchDialog.ShowCustom(dlg,"","","")
			txtSearchString.RequestFocus
			Wait For (rs) Complete (Result As Int)
			 
		' clear filter
		Case 1
			' prikažemo novi grid
			SetFilterStyle(0, "")
			NeedToInit = True
			frm.Close

		' view all columns			
		Case 2
			ViewColumns
			NeedToInit = True

		' hide column 
		Case 3
			HideColumn(SelectedColumnName)
			NeedToInit = True
			
		' save configuration 						
		Case 4
			SaveConfig
			
		' set to default view 
		Case 5
			SetToDefaultLayout
			tblView.Items.Clear
			NeedToInit = True
			
		' export to xls 
		Case 6
			Dim fc As FileChooser
			fc.Initialize
			fc.Title = "Export to excel"
			fc.SetExtensionFilter("Excel files", Array As String("*.xls"))
			Dim FullFileName As String = fc.ShowSave(frm)
			
			If FullFileName = "" Then Return
			
			Dim fs As Map = DbComm.SplitFilePath(FullFileName)
			Dim Path As String = fs.GetKeyAt(0)
			Dim FileName As String = fs.GetValueAt(0)
			Dim SheetName As String = FileName.SubString2(0, FileName.IndexOf("."))
			Export2Xls(Path, SheetName, FileName)
			
	End Select
	frm.Close
	
End Sub

' change object to map 
Sub DataToMap(Record() As Object) As Map
	Dim mapRec As Map
	mapRec.Initialize
	
	For x = 0 To mapColumns.Size - 1
		Dim cl As colRec = mapColumns.GetValueAt(x)
		mapRec.Put(cl.colId, Record(cl.colPos))
		If cl.colType = "CHECKBOX" Then
			Dim chk As CheckBox = Record(cl.colPos)
			If chk.Checked Then mapRec.Put(cl.colId, 1) Else mapRec.Put(cl.colId, 0)
		End If
	Next
	
	Return mapRec
End Sub

' search item 
Private Sub txtSearchString_Action
	
	Dim Items As List
	Items.Initialize
	
	Log(tblView.Items.Size)
	
	' poiščemo po vseh kolonah in filtriramo rezultate
	For x = 0 To tblView.Items.Size -1
		Dim row() As Object = tblView.Items.Get(x)
		Dim Item As Map = DataToMap(row)
		' Log(Item)
		
		' preverimo vsak string
		For i = 0 To Item.Size -1
			Dim str As String = Item.GetValueAt(i)
			If str.ToLowerCase.Contains(txtSearchString.Text.Trim.ToLowerCase) = True Then Items.Add(row)
		Next
	Next
	
	' prikažemo novi grid
	tblView.Items.Clear
	tblView.Items.AddAll(Items)
	' postavimo filter na kolono
	SetFilterStyle(0, "darkred")
		
	' zapremo dialog
	searchDialog.Close(1)
End Sub