﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Public Root As B4XView
	Private xui As XUI
	Private tblGrid As TableView
	Private btnLoad As Button
	Private btnExit As Button
	
	Private cfgTable As configTable
	
	
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	DbComm.InitDb
	
	' Create tableview 
	CreateTableViewGrid 
	
End Sub

' routine to creating tableview from sqllite 
Private Sub CreateTableViewGrid
	
	' init of tablegrid configuratin 
	cfgTable.Initialize(tblGrid, "MainPage")
	' UserID 
	cfgTable.UserID = 0 

	' creating columns 
	cfgTable.CreateColumn("ID", 0, 60dip, True, "INT")
	cfgTable.CreateColumn("Name", 1, 60dip, True, "TEXT")
	cfgTable.CreateColumn("Is big", 2, 60dip, True, "CHECKBOX")
	cfgTable.CreateColumn("Country", 3, 120dip, False, "TEXT")
	cfgTable.CreateColumn("Population", 4, 150dip, True, "TEXT")

	' get all colums in map 
	Dim Cols As Map = cfgTable.mapColumns
	
	Dim l As List
	l.Initialize
	
	' postavimo kolone
	For x = 0 To Cols.Size - 1
		l.Add(Cols.GetKeyAt(x))
	Next
	tblGrid.SetColumns(l)

	' default settings 
	For x = 0 To Cols.Size - 1
		Dim clm1 As colRec = Cols.GetValueAt(x)
		tblGrid.SetColumnWidth(x, clm1.colOrigLength)
		tblGrid.SetColumnVisible(x, clm1.colVisible)
	Next

	' load saved user config
	tblGrid = cfgTable.LoadConfig
	

End Sub


' select data from datase and fill grid 
Private Sub RefreshGrid
	
	tblGrid.Items.Clear
	Dim Query As String  = $"select CityIdent,
							       CityIsRealyBig,
							       CityName,
							       CityASCII,
							       CityLat,
							       CityLng,
							       CityIso2,
							       CityIso3,
							       CityFree,
							       CityCapital,
							       CityFree_1,
							       CityPopulation
							  FROM Citys
							  ;
					"$
	Dim rs As ResultSet = DbComm.SqlLite.ExecQuery(Query)

	' filling grid with exact order as is created in initgrid 	
	Do While rs.NextRow
		Dim row() As Object = Array(rs.GetInt("CityIdent"), rs.GetString("CityName"), rs.GetInt("CityIsRealyBig"), rs.GetString("CityIso2"),rs.GetInt("CityPopulation"))
		' reconfigure items with saved order and visibility
		tblGrid.Items.Add(cfgTable.ReconfigureItems(row))
	Loop
	rs.Close
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Private Sub btnExit_Click
	ExitApplication
End Sub

Private Sub btnLoad_Click
	' refresh grid - filling grid with data
	RefreshGrid
End Sub

' click on item 
Private Sub tblGrid_SelectedRowChanged(Index As Int, Row() As Object)
	Dim Item As Map = cfgTable.DataToMap(tblGrid.Items.Get(Index))
	
	' log item from grid by name of column 
	Log("Selected row:" & Index & "--> " & Item.Get("CityName"))
End Sub

' if user click in grid 
Private Sub tblGrid_MouseClicked (EventData As MouseEvent)
	
	' remember mouse position 
	Dim Jo As JavaObject = EventData
	Dim Left As Double = Jo.RunMethod("getScreenX", Null)
	Dim Top As Double = Jo.RunMethod("getScreenY", Null)
	
	' double click 
	If EventData.PrimaryButtonPressed = True And EventData.ClickCount = 2 Then
		Log("doubleclick") 
	End If
	
	' right click 
	If EventData.SecondaryButtonPressed = True Then

		Dim ContextMenuEvent As JavaObject = EventData
		Dim Target As JavaObject = ContextMenuEvent.RunMethod("getTarget", Null)

		If Target Is Node Then
			Dim n As Node = Target
			Do While n.IsInitialized
				' when user click in head of table 
				If GetType(n) = "javafx.scene.control.skin.TableColumnHeader" Then
					Dim Jo As JavaObject = Target
					cfgTable.SelectedColumnName = Jo.RunMethod("getText", Null)
					cfgTable.ShowMenu(Left, Top)
					' if user hide column or change the order - create grid again 
					If cfgTable.NeedToInit Then 
						CreateTableViewGrid
						RefreshGrid
					End If
				End If
				
				n = n.Parent
			Loop
		End If

	End If
	
End Sub